// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.

package org.apache.doris.mtmv;

import org.apache.doris.mtmv.metadata.MTMVJob;
import org.apache.doris.mtmv.metadata.MTMVTask;
import org.apache.doris.qe.ConnectContext;

import java.util.Map;

public class MTMVTaskContext {
    ConnectContext ctx;
    String query;
    Map<String, String> properties;
    MTMVTask task;
    MTMVJob job;

    public ConnectContext getCtx() {
        return ctx;
    }

    public void setTask(MTMVTask task) {
        this.task = task;
    }

    public MTMVTask getTask() {
        return this.task;
    }

    public void setJob(MTMVJob job) {
        this.job = job;
    }

    public MTMVJob getJob() {
        return this.job;
    }

    public void setCtx(ConnectContext ctx) {
        this.ctx = ctx;
    }

    public String getQuery() {
        return query;
    }

    public void setQuery(String query) {
        this.query = query;
    }

    public Map<String, String> getProperties() {
        return properties;
    }

    public void setProperties(Map<String, String> properties) {
        this.properties = properties;
    }
}
