CREATE TABLE IF NOT EXISTS `lineorder` (
  `lo_orderdate` int(11) NOT NULL COMMENT "",
  `lo_orderkey` bigint(20) NOT NULL COMMENT "",
  `lo_linenumber` bigint(20) NOT NULL COMMENT "",
  `lo_custkey` int(11) NOT NULL COMMENT "",
  `lo_partkey` int(11) NOT NULL COMMENT "",
  `lo_suppkey` int(11) NOT NULL COMMENT "",
  `lo_orderpriority` varchar(16) NOT NULL COMMENT "",
  `lo_shippriority` int(11) NOT NULL COMMENT "",
  `lo_quantity` bigint(20) NOT NULL COMMENT "",
  `lo_extendedprice` bigint(20) NOT NULL COMMENT "",
  `lo_ordtotalprice` bigint(20) NOT NULL COMMENT "",
  `lo_discount` bigint(20) NOT NULL COMMENT "",
  `lo_revenue` bigint(20) NOT NULL COMMENT "",
  `lo_supplycost` bigint(20) NOT NULL COMMENT "",
  `lo_tax` bigint(20) NOT NULL COMMENT "",
  `lo_commitdate` bigint(20) NOT NULL COMMENT "",
  `lo_shipmode` varchar(11) NOT NULL COMMENT "",
  INDEX lo_orderdate_idx(lo_orderdate) USING INVERTED COMMENT 'lo_orderdate index',
  INDEX lo_orderkey_idx(lo_orderkey) USING INVERTED COMMENT 'lo_orderkey index',
  INDEX lo_linenumber_idx(lo_linenumber) USING INVERTED COMMENT 'lo_linenumber index',
  INDEX lo_custkey_idx(lo_custkey) USING INVERTED COMMENT 'lo_custkey index',
  INDEX lo_partkey_idx(lo_partkey) USING INVERTED COMMENT 'lo_partkey index',
  INDEX lo_orderpriority_idx(lo_orderpriority) USING INVERTED COMMENT 'lo_orderpriority index',
  INDEX lo_ordtotalprice_idx(lo_ordtotalprice) USING INVERTED COMMENT 'lo_ordtotalprice index'
)
UNIQUE KEY (`lo_orderdate`,`lo_orderkey`,`lo_linenumber`)
PARTITION BY RANGE(`lo_orderdate`)
(PARTITION p1992 VALUES [("-2147483648"), ("19930101")),
PARTITION p1993 VALUES [("19930101"), ("19940101")),
PARTITION p1994 VALUES [("19940101"), ("19950101")),
PARTITION p1995 VALUES [("19950101"), ("19960101")),
PARTITION p1996 VALUES [("19960101"), ("19970101")),
PARTITION p1997 VALUES [("19970101"), ("19980101")),
PARTITION p1998 VALUES [("19980101"), ("19990101")))
DISTRIBUTED BY HASH(`lo_orderkey`) BUCKETS 48
PROPERTIES (
"compression"="zstd",
"replication_num" = "1",
"enable_unique_key_merge_on_write" = "true"
);
